/*******************************************************************************
 * Copyright (c) 2014 Karlsruhe Institute of Technology, Germany
 *                    Technical University Darmstadt, Germany
 *                    Chalmers University of Technology, Sweden
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Technical University Darmstadt - initial API and implementation and/or initial documentation
 *******************************************************************************/

package org.key_project.sed.core.util;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.key_project.sed.core.annotation.ISEDAnnotationType;

/**
 * Initializes the default preferences accessible via {@link SEDPreferenceUtil}.
 * @author Martin Hentschel
 */
public class SEDPreferenceUtilInitializer extends AbstractPreferenceInitializer {
   /**
    * {@inheritDoc}
    */
   @Override
   public void initializeDefaultPreferences() {
      SEDPreferenceUtil.setDefaultShowCompactExecutionTree(true);
      for (ISEDAnnotationType type : SEDAnnotationUtil.getAnnotationtypes()) {
         SEDPreferenceUtil.setDefaultAnnotationTypeHighlightBackground(type);
         SEDPreferenceUtil.setDefaultAnnotationTypeBackgroundColor(type);
         SEDPreferenceUtil.setDefaultAnnotationTypeHighlightForeground(type);
         SEDPreferenceUtil.setDefaultAnnotationTypeForegroundColor(type);
      }
   }
}